import java.sql.*;
import java.util.Properties;

public class testAccess {
    public static void main(String[] args) throws Exception {
        try{
            String jdbURL = "jdbc:access:/./?caseInsensitive=true";

                Class.forName("com.caigen.sql.access.AccessDriver");

                Properties props = new Properties();
                props.setProperty("delayedClose", "0");

                Connection conn = DriverManager.getConnection(jdbURL, props);
                Statement stmt = conn.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_UPDATABLE);

                String sql="create database if not exists testdb;";
                System.out.println(sql);
                stmt.executeUpdate(sql);
                conn.setCatalog("testdb");

                sql="create table if not exists testUsers  (FirstName varchar(25), LastName varchar(25));";
                System.out.println(sql);
                stmt.execute(sql);

                sql="insert into testUsers values('John','Pull');";
                System.out.println(sql);
                stmt.execute(sql);

                sql="insert into testUsers values('Tom','Cat');update testUsers set LastName='Tiger' where LastName='Cat';delete from testUsers where LastName='Tiger';";
                System.out.println(sql);
                stmt.execute(sql);

                sql="SELECT FirstName+' '+LastName as UserName FROM testUsers";
                System.out.println(sql);
                ResultSet rs = stmt.executeQuery(sql);
                ResultSetMetaData resultSetMetaData = rs.getMetaData();
                int iNumCols = resultSetMetaData.getColumnCount();
                for (int j = 1; j <= iNumCols; j++) {
                    System.out.println(resultSetMetaData.getColumnName(j)
                        + "  " + resultSetMetaData.getColumnTypeName(j)
                        + "  " + resultSetMetaData.getPrecision(j)
                        + "  " + resultSetMetaData.getScale(j)
                        );
                }
                Object colval;

                while (rs.next()) {
                    for (int j = 1; j <= iNumCols; j++) {
                        colval = rs.getObject(j);
                        System.out.print(colval + "\t");
                    }
                    System.out.println();
                }

                rs.close();

                sql="drop table if exists testUsers;";
                System.out.println(sql);
                stmt.execute(sql);

                conn.setCatalog(null);

                sql="drop database if exists testdb;";
                System.out.println(sql);
                stmt.execute(sql);

                stmt.close();

                conn.close();
        }
        catch( SQLException sqle )
        {
            do
            {
                System.out.println(sqle.getMessage());
                System.out.println("Error Code:"+sqle.getErrorCode());
                System.out.println("SQL State:"+sqle.getSQLState());
                sqle.printStackTrace();
            }while((sqle=sqle.getNextException())!=null);
        }
        catch( Exception e )
        {
            System.out.println(e.getMessage());
            e.printStackTrace();
        }
    }


}
